/**
 * ALLYouTubeDownloader 0.8.5 for Firefox & SeaMonkey
 *
 * @author Sebastian Stala {Scripter1}
 * @copyright 2014
 */
 
var isAYDbutton;
var oldBrowser;

var YouTubetoALL_urlBarListener = {
  QueryInterface: function(aIID)
  {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
  },

  onLocationChange: function(aProgress, aRequest, aURI)
  {
    YouTubetoALL.NewURL(aURI);
  },

  onStateChange: function(a, b, c, d) {},
  onProgressChange: function(a, b, c, d, e, f) {},
  onStatusChange: function(a, b, c, d) {},
  onSecurityChange: function(a, b, c) {}
};

var YouTubetoALL = {
	onLoad : function() {
		gBrowser.addProgressListener(YouTubetoALL_urlBarListener);
		window.document.addEventListener("DOMContentLoaded", YouTubetoALL.DOMContentLoaded, true);
	},
	
	NewURL: function(aURI) {
		var url = aURI.spec;
 		if (url == this.oldURL)
		return;
    
		// now we know the url is new...
//		isAYDbutton = "";
		var ver = YouTubetoALL.browserCheck("getver");
		if (url.match(/^https?:\/\/www\.youtube\.com\/watch\?.*/)){
	    	if (ver>=4){
	    		var down = document.getElementById('appmenu_youtube-to-all-download').setAttribute("disabled", "false");
	    	}
	    	var down = document.getElementById('tools_youtube-to-all-download').setAttribute("disabled", "false");
	    } else {
	    	if (ver>=4){
	    		var down = document.getElementById('appmenu_youtube-to-all-download').setAttribute("disabled", "true");
	    	}
	    	var down = document.getElementById('tools_youtube-to-all-download').setAttribute("disabled", "true");
	    }
    
		this.oldURL = url;
		return;
  },

	
	// Opens the help
	about: function(){
//		var win = window.open("chrome://YouTubetoALL/content/About.xul", "aboutMyExtension", "chrome,centerscreen");
		window.getBrowser().selectedTab = window.getBrowser().addTab("http://www.allplayer.org/youtube-to-allplayer");
	},
	
	browserCheck: function(mode){
		var mode;
		var result;
//		alert (mode);
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
 	          .getService(Components.interfaces.nsIXULAppInfo);
		if (mode == "getver"){
			info.version; // Returns "2.0.0.1" for Firefox version 2.0.0.1
			if (info.version.charAt(1)=="."){				
				if (info.version.charAt(3)){
					var ver = info.version.charAt(0)+info.version.charAt(1)+info.version.charAt(2)+info.version.charAt(3);
				} else {
					var ver = info.version.charAt(0)+info.version.charAt(1)+info.version.charAt(2);
				};
			}
			else {
			var ver = info.version.charAt(0)+info.version.charAt(1);
			}
			result = ver;
		} else if (mode == "getapp"){		//future functions
			// Get the name of the application running us
			app = info.name; // Returns "Firefox" for Firefox
			result = app;
		} else if (mode == "getid"){
			// Get the name of the application running us
			id = info.ID;
			// Returns application ID
			// FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}"
			// THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}"
			// SEAMONKEY_ID = "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}"
			result = id; 
		};
//		alert (result);
		return  (result);
	},
	
	urlCheck: function(event){
		var doc = YouTubetoALL.tabCheck(event);
		var loc = doc.location;
//		var loc = document.location
		if (loc.href.match(/^https?:\/\/www\.youtube\.com\/watch\?.*/)){
			var ytube = "yes";
		} else {
			var ytube = "no";
		}
		return(ytube);
	},
	
	downLoad: function(){
		var osString = Components.classes["@mozilla.org/xre/app-info;1"]  
        	      .getService(Components.interfaces.nsIXULRuntime).OS;
		var tab = Components.classes['@mozilla.org/appshell/window-mediator;1']
                  .getService(Components.interfaces.nsIWindowMediator);
		var doc = tab.getMostRecentWindow("navigator:browser").content.document;
		var loc = doc.location;
		var path = YouTubetoALL.YtALLpath(osString);
		YouTubetoALL.runDownloader(doc, path);
	},
	
	YtALLpath: function(osString){
		if (osString=="WINNT") {
			var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
                  			.createInstance(Components.interfaces.nsIWindowsRegKey);
			wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall",wrk.ACCESS_READ);
			if (wrk.hasChild("ALL YouTube Downloader_is1")){ //YtALL jest zainstalowane
				var subkey = wrk.openChild("ALL YouTube Downloader_is1", wrk.ACCESS_READ);
				var appver = subkey.readStringValue("DisplayVersion");
				if (appver>="2.3" && appver<"2.5"){
					if (subkey.hasValue("DisplayIcon")){ //jest sciezka
						var path = subkey.readStringValue("DisplayIcon");
					} else { //brak sciezki, probably never will happen...
						var path ="%PROGRAMFILES%\\ALLYouTubeDownloader\\ALLYouTubeDownloader.exe"; // ?
					}
				} else if (appver<"2.3") {
					var path ="old_ver";
				} else {
					var path ="wrong_ver";
				}
				subkey.close();
			} else { // YtALL nie jest zainstalowane
				var path ="no_path";
			}
			wrk.close();
		} else {
			var path ="not_winnt";
	    }
	    return (path);
	},
	
	tabCheck: function(event){
		var doc = event.originalTarget;
		return doc;
	},
	
	DOMContentLoaded : function(event) {
		// Listen for webpage loads
		
		var brName = YouTubetoALL.browserCheck("getapp");		
		var ver = YouTubetoALL.browserCheck("getver");
		var brID = YouTubetoALL.browserCheck("getid");
		if (oldBrowser != "old"){
			if (brID == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}" && ver < "14"){	//Firefox
				oldBrowser = "old";
				var strbundle = document.getElementById("YtA-strings");
				var alert_str = strbundle.getString("old_browser_a")+" "+brName+strbundle.getString("old_browser_b");
				alert(alert_str);
			} else if (brID == "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}" && ver < "2.11"){	//SeaMonkey
				oldBrowser = "old";
				var strbundle = document.getElementById("YtA-strings");
				var alert_str = strbundle.getString("old_browser_a")+" "+brName+strbundle.getString("old_browser_b");
				alert(alert_str);
			};
		};
		
		// Returns "WINNT" on Windows Vista, XP, 2000, and NT systems;  
    	// "Linux" on GNU/Linux; and "Darwin" on Mac OS X.  
    	var osString = Components.classes["@mozilla.org/xre/app-info;1"]  
        	        .getService(Components.interfaces.nsIXULRuntime).OS;
     	var doc = getBrowser().selectedBrowser.contentDocument;
//		var doc = event.explicitOriginalTarget;
		var ytube = YouTubetoALL.urlCheck(event);
		if (ytube=="yes") {	
			var path = YouTubetoALL.YtALLpath(osString);
			YouTubetoALL.setButton(doc, path);
		}
		
	},

	setButton : function(doc, path) {
		var label = "ALLYouTubeDownloader";
		var l = doc.createElement("button");

		var YtA_tooltip = "Zapisz ten film na Swoim dysku";
		l.style.marginLeft = "3px"
		l.innerHTML = label	//napis na przycisku
		
		l.setAttribute("class", "yt-uix-tooltip yt-uix-button yt-uix-button-default yt-uix-tooltip yt-uix-button-empty")
		l.setAttribute("id", "ALLYouTubeDownloader")
		l.setAttribute("closure_uid_2rpxjo", "1")
		l.setAttribute("title", YtA_tooltip)	//dymek
		l.setAttribute("data-tooltip-text", YtA_tooltip)	//dymek - to fix
		l.setAttribute("data-tooltip-timer", "2349728")
//		l.setAttribute("border-bottom-color", "#CC181E")
		
		l.setAttribute("href", "#")
		l.setAttribute("onclick", "return false")
		l.addEventListener("click",function() {
			YouTubetoALL.runDownloader(doc, path);
		},false);

		ALLActions = doc.getElementById("watch7-secondary-actions");
//		ALLActions.style.width = "auto";
//		ALLActions.parentNode.insertBefore(downloadLinks, ALLActions);
		if (ALLActions){
			
			AYDButton = doc.getElementById("ALLYouTubeDownloader");
			if (!AYDButton){						
				ALLActions.appendChild(l);
			} else {
//				alert ("Button alredy added");
			}
//			isAYDbutton = "yes";
//		} else if (isAYDbutton=="yes") {	// avoid adding button which is already added
//			alert ("Button alredy added");
//		} else if (isAYDbutton=="YTchanged") {	// avoid unnecessary "YouTube changed" alert
//			alert ("You again???");
//		} else {
//			isAYDbutton = "YTchanged"	// YouTube site has changed...
//			var strbundle = document.getElementById("YtA-strings");
//			var alert_str = strbundle.getString("yt_change");
//			alert(alert_str);
		}
	},
	
	runDownloader : function (doc, path){
		if (doc.location=="about:blank")
			return;

		var strbundle = document.getElementById("YtA-strings");
//		var path = "not_winnt";	//test function
		
		if (path=="no_path") {
			var alert_str = strbundle.getString("no_path");
			alert(alert_str);
		} else if (path=="old_ver"){
			var alert_str = strbundle.getString("old_ver");
			alert(alert_str);
		} else if (path=="wrong_ver"){
			var alert_str = strbundle.getString("wrong_ver");
			alert(alert_str);
		} else if (path=="not_winnt") {
			var alert_str = strbundle.getString("not_winnt");
			alert(alert_str);
		} else {			
				// create an ns_ILocalFile or ns_IFile for the executable - 1 czesc
				var file = Components.classes["@mozilla.org/file/local;1"]			
                     .createInstance(Components.interfaces.nsIFile);
			         //for FF <14 & SM <2.11 compatibility should be used `nsILocalFile`
				file.initWithPath(path);

				// create an ns_IProcess - 2 czesc
				var process = Components.classes["@mozilla.org/process/util;1"]
    				.createInstance(Components.interfaces.nsIProcess);
				process.init(file);

				// Run the process.
				// If first param is true, calling thread will be blocked until
				// called process terminates.
				// Second and third params are used to pass command-line arguments
				// to the process.
				var args = [doc.location];
				process.run(false, args, args.length);
		}
	},
}
window.addEventListener("load", YouTubetoALL.onLoad, false);